<?php // dns_data.php: chok(tue 9 jul 2002)

// generate report on disparities between DNS file data
// and actual scanned data in Ecescan database


/*  CGI var:

	ip_regex: regex for the IP addresses to be displayed
*/


require_once('db.php');


function dns_data_merged($ip_regex)
// returns $ips
// $ips is an array of ('long_ip'=>$long_ip, 'ip'=>$ip, 'hostname'=>$hostname,
// 'disagreement'=>$disagreement) sorted by long_ip
{
	// get all data from table 'dns_comparisons'
	$ips = array();
	$aa = db_rows("select long_ip, ip, hostname, disagreement
		from dns_comparisons where ip regexp '$ip_regex' order by long_ip");
	foreach($aa as $a)
		$ips[] = array('long_ip'=>$a[0], 'ip'=>$a[1],
			'hostname'=>$a[2], 'disagreement'=>$a[3]);

	return $ips;
}

function dns_data_separate($ip_regex)
// returns ($ips_dns, $ips_ece)
// $ips_dns and $ips_ece are arrays of ('long_ip'=>$long_ip, 'ip'=>$ip,
// 'hostname'=>$hostname, 'disagreement'=>$disagreement) sorted by long_ip
{
	// get $ips_dns from table 'dnstemp'
	$ips_dns = array();
	$aa = db_rows("select long_ip, ip, hostname, disagreement
		from dns_comparisons where based_on='DNS' and ip regexp '$ip_regex'
		order by long_ip");
	foreach($aa as $a)
		$ips_dns[] = array('long_ip'=>$a[0], 'ip'=>$a[1],
			'hostname'=>$a[2], 'disagreement'=>$a[3]);

	// get $ips_ece from table 'ecetemp'
	$ips_ece = array();
	$aa = db_rows("select long_ip, ip, hostname, disagreement
		from dns_comparisons where based_on='ECE' and ip regexp '$ip_regex'
		order by long_ip");
	foreach($aa as $a)
		$ips_ece[] = array('long_ip'=>$a[0], 'ip'=>$a[1],
			'hostname'=>$a[2], 'disagreement'=>$a[3]);

	return array($ips_dns,$ips_ece);
}


?>
