<?php // handle_vars.php: chok(tue 9 jul 2002)

// load/save the CGI vars in file if needed
// also loads default values for the vars

/*	use:

	1. to load vars only
	require_once('handle_vars.php');

	2. to load and save vars
	require_once('handle_vars.php');
	vars_save();

	3. to load, define and save vars
	require_once('handle_vars.php');
	vars_set_from_env(array('var1','var2'));
	vars_save();
*/





// get file to save the data in
$vars_file = "output/.vars_$REMOTE_HOST$REMOTE_ADDR";
$vars_arr = array();
$vars_changed = 0;





/*
	CGI vars
	--------
	subnet_ip_regex = string
	rows_per_page	= number
	start_row		= number
	ip_regex		= string
	min_DaysOffline	= string
	os_group		= '' | win | unix | misc | unid | other, for os_regex (radio)
	os_regex		= string, for os_group(other)
	show_XX where XX = IP | Hostname | OS | Active | Total | PercentActive
		| DateInserted | LastActive | LastModified | DaysOffline (checkbox)
	sort_field	= LongIP | Hostname | OS | PercentActive | DateInserted | LastActive | DaysOffline (radio)
	sort_order	= asc | desc (radio)
	include_dns	= include the DNS comparison in the display, 1 or 0
	include_dns_only = include the DNS comparison only, 1 or 0
	duphosts_only = 1 | NULL

	dns_ip_regex = string, from dns.php only

	// hostname chgs
	by_month = '05-2001'
	last_weeks = number
	last_days = number
	${from|to}_{mth|day|yr} = '05'|'05'|'2001'

	hc_sort_field = ip | oldhostname | newhostname | updatetime
	hc_sort_order = asc | desc

	$use_{by_month|last_weeks|last_days|exact_dates} = 1 | NULL
*/


// list of all CGI vars to handle
$cgi_vars = array(
	'subnet_ip_regex', 'rows_per_page', 'start_row',
	'ip_regex', 'min_DaysOffline', 'os_group', 'os_regex',
	'show_IP', 'show_Hostname', 'show_OS', 'show_Active', 'show_Total',
	'show_PercentActive', 'show_DateInserted', 'show_LastActive',
	'show_LastModified', 'show_DaysOffline',
	'sort_field', 'sort_order', 'include_dns', 'include_dns_only', 'duphosts_only',

	'dns_ip_regex', // for DNS cmp report only

	'by_month', 'last_weeks', 'last_days',
	'from_mth', 'from_day', 'from_yr', 'to_mth', 'to_day', 'to_yr',

	'hc_sort_field', 'hc_sort_order',

	'use_by_month', 'use_last_weeks', 'use_last_days', 'use_exact_dates'
);













// load all default values only if file does not exist
if(! file_exists($vars_file)):
  if( strlen($show_IP)==0 ) $show_IP = 1;
  if( strlen($show_Hostname)==0 ) $show_Hostname = 1;
  if( strlen($show_PercentActive)==0 ) $show_PercentActive = 1;
  if( strlen($show_DateInserted)==0 ) $show_DateInserted = 1;
  if( strlen($show_LastActive)==0 ) $show_LastActive = 1;
  if( strlen($show_DaysOffline)==0 ) $show_DaysOffline = 1;

  if( strlen($sort_field)==0 ) $sort_field = 'IP';
  if( strlen($sort_order)==0 ) $sort_order = 'asc';

  if( strlen($rows_per_page)==0 ) $rows_per_page = 100;
endif;







function vars_save()
// save all vars back into file if any vars changed
{
	global $vars_file, $vars_arr, $vars_changed;

	// grab all vars from environment, CGI
	global $cgi_vars;
	foreach($cgi_vars as $v):
		global $$v;
		if(isset($$v)) {$vars_arr[$v]=$$v; $vars_changed=1;}
	endforeach;

	// load all vars from file that are missing from env
	if(file_exists($vars_file) && filesize($vars_file)):
		$f = file($vars_file) or die($vars_file);
		foreach($f as $s):
			if(! ereg('^[[:space:]]*([^[:space:]]+)[[:space:]]*=(.*)$', $s, $regs))
				continue;	// invalid line, ignore

	  		// valid line, save the var
	  		$v = $regs[1];
	  		if(! array_key_exists($v,$vars_arr)):
	  			global $$v;
	  			$$v = $vars_arr[$v] = trim($regs[2]);
	  		endif;
		endforeach;
	endif;

	// save all vars if any changes made
	if( $vars_changed ):
		$do_chmod=0;
		if(! file_exists($vars_file)) $do_chmod=1;

		$fh = fopen($vars_file,'w') or die($vars_file);
		while( list($var,$val) = each($vars_arr) )
			fwrite($fh, "$var=$val\n");
		fclose($fh);

		if($do_chmod) chmod($vars_file,0666);

		$vars_changed = 0;
	endif;
}



function vars_set_from_env( $vars )
// set the vars for sure from environment
{
	global $vars_arr, $vars_changed;

	$vars_changed = 1;

	foreach($vars as $v):
		global $$v;
		$vars_arr[$v] = $$v;
	endforeach;
}


?>
