<?php // view_data.php: chok(tue 9 jul 2002)

require_once('draw.php');
?>


<html>

<head>
<title>Ecescan Data</title>
<link type="text/css" rel="stylesheet" href="style.css">
</head>

<body>




<?php









//
//  document header and table title
//

// load vars from file and update if nec
require_once('handle_vars.php');
vars_save();

if(strcmp($view_mode,'DupHosts')==0):
	draw_title('Duplicate Hostnames', 1,  // 1 for additional stuff
		'home.php', 'Back to Home Page');

	// don't save this burger
	$duphosts_only = 1;
else:
	draw_title('Ecescan Data', 1,  // 1 for additional stuff
		'queryform.php', 'Back to Query Form');
endif;

flush();














//
//  check whether user is authorized to edit the table or not
//


// runs a Perl script to do the checking
$auth = `/export/home1/supervision/ecescan/checkauthwebuser $PHP_AUTH_USER`;


















//
//  form SQL where clause
//

$wheres = $print_wheres = array();

// make IP regex
if( strlen($subnet_ip_regex) ):
	$wheres[] = "IP regexp '$subnet_ip_regex'";
	$print_wheres[] = "IP matching '$subnet_ip_regex'";
endif;

if( strlen($ip_regex) ):
	$wheres[] = "IP regexp '$ip_regex'";
	$print_wheres[] = "IP matching '$ip_regex'";
endif;

// form 'where' from $min_DaysOffline
if( strlen($min_DaysOffline) ):
	$wheres[] = "DaysOffline >= $min_DaysOffline";
	$print_wheres[] = "Minimum $min_DaysOffline days offline";
endif;


// make OS 'where' clause
$os_unretrievable	= 'OS info unretrievable';	// from ecescan.data
$os_null			= 'Unspecified OS';
$os_unknown			= 'OS unknown';

$os_types = array (
	'win'	=> 'Win|Microsoft',
	'unix'	=> 'HP-UX|SunOS|Solaris|IRIX|Ultrix|Linux|BSD',
	'unid'	=> "$os_unretrievable|$os_null|$os_unknown"
);

$os_regexes = array (
	''		=> "",	// ALL
	'win'	=> "OS regexp '${os_types['win']}'",
	'unix'	=> "OS regexp '${os_types['unix']}'",
	'misc'	=> "not( OS regexp '${os_types['win']}|${os_types['unix']}|"
		. "${os_types['unid']}' or OS = '' or OS is NULL )",
	'unid'	=> "OS regexp '${os_types['unid']}' or OS = '' or OS is NULL",
	'other'	=> "OS regexp '$os_regex'"
);

$os_print = array (
	'win'	=> 'Microsoft Windows systems',
	'unix'	=> 'UNIX systems',
	'misc'	=> 'Miscellaneous (eg switches, routers)',
	'unid'	=> 'Unidentified systems',
	'other'	=> 'Other operating systems'
);

$regex = $os_regexes[$os_group];
if( strlen($regex) ):
	$wheres[] = $regex;
	$print_wheres[] = $os_print[$os_group];
endif;




// check whick fields to display

// create the $fields[] variable from $show_XX variables
// necessary becos of Javascript not allowing '[]' in var name

if(! is_array($fields)) $fields = array();
if($show_IP && !in_array('IP',$fields)) $fields[]='IP';
if($show_Hostname && !in_array('Hostname',$fields)) $fields[]='Hostname';
if($show_OS && !in_array('OS',$fields)) $fields[]='OS';
if($show_Active && !in_array('Active',$fields)) $fields[]='Active';
if($show_PercentActive && !in_array('PercentActive',$fields)) $fields[]='PercentActive';
if($show_DateInserted && !in_array('DateInserted',$fields)) $fields[]='DateInserted';
if($show_LastActive && !in_array('LastActive',$fields)) $fields[]='LastActive';
if($show_LastModified && !in_array('LastModified',$fields)) $fields[]='LastModified';
if($show_DaysOffline && !in_array('DaysOffline',$fields)) $fields[]='DaysOffline';

// select default fields if nec
if( sizeof($fields)==0 )
	$fields = array('IP','Hostname','PercentActive','DateInserted',
		'LastActive','DaysOffline');




// ensure that the 'longIP' field is always there only if user is authorized
if($auth) $fields[] = 'LongIP';




// view duplicate hostnames only
if( $duphosts_only ):
	$wheres[] = "duplicated_hostname='1'";
	$print_wheres[] = 'Duplicate hostnames';
endif;


// make final 'where' clause
if( sizeof($wheres) ):
	$where = 'where( ' . join( ' and ', $wheres ) . ')';
else:
	$where = '';
endif;









//
//  make SQL 'order by' clause
//

if( strlen($sort_field)==0 ) $sort_field = $fields[0]; // default to 1st field
if( strlen($sort_order)==0 ) $sort_order = 'asc';	// default to ascending order

// always sort by 'LongIP', never by 'IP'
if(strcmp($sort_field,'LongIP')==0) $sort_field='IP';

if(strcmp($sort_field,'IP')==0) $s='LongIP';
else $s=str_replace(' ','',$sort_field);


$order_by = "order by $s $sort_order";






















//
//  get data from the database and other sources for the report
//

if($include_dns_only):

	$include_dns = 1;

	$all_data = array();
	$data_count = $rows_count = 0;

else:

	require_once( 'db.php' );

	// format the date for the sql query
	$f = $fields;
	for( $i=0, $count=sizeof($f); $i<$count; $i++ ):
		switch($f[$i]):
		case('DateInserted'):
		case('LastActive'):
		case('LastModified'): $f[$i] = db_date_format($f[$i]);
		endswitch;
	endfor;

	// perform the query
	$sql = "select " . join( ',', $f ) . " from iptable $where $order_by";
	$all_data = db_rows($sql);
	$data_count = $rows_count = sizeof($all_data);

endif;











// find field indices in $fields[]
for( $ipFieldNum=$hostnameFieldNum=$osFieldNum=-1,
	$i=0; $i<sizeof($fields); $i++ ):

	// find the field number of IP to highlight and for DNS cmp
	if( strcmp($fields[$i],'IP')==0 )
		$ipFieldNum = $i;

	// get the field number of Hostnames to hightlight in red bold
	// also, to compare for DNS cmp
	elseif( strcmp($fields[$i],'Hostname')==0 )
		$hostnameFieldNum = $i;

	// get the field number of OS to hightlight in blue bold
	elseif( strcmp($fields[$i],'OS')==0 )
		$osFieldNum = $i;

endfor;












//
// add DNS comparison data if $include_dns is set


if($include_dns):
	require_once('dns_data.php');

	$regexes = array();
	if( strlen($subnet_ip_regex) ) $regexes[] = $subnet_ip_regex;
	if( strlen($ip_regex) ) $regexes[] = $ip_regex;
	if(sizeof($regexes)==0) $regex = '.*'; // match all
	else $regex = '((' . join(')|(', $regexes) . '))';

	$ips = dns_data_merged($regex);
	$count_disagree = sizeof($ips);

	// insert the DNS comparison data into $all_data if nec
	if( $count_disagree ):

		$newarr = array();
		$desc = !strcmp($sort_order,'desc');

		// $ips already sorted accordingly to long_ip
		switch($sort_field):

		case('IP'):
		case('LongIP'):
			// insert by LongIP order, asc or desc

			if($ipFieldNum == -1)
				die("IP must be displayed if sort field is IP");

			// array merge
			$d = $a = 0;
			if($desc) $d=$count_disagree-1;

			while(1):
				// if reversed order, then iterate backwards
				$cmp = $desc ? ($d<0) : ($d>=$count_disagree);
				if($cmp):
					// finished $ips, so copy remaining $all_data
					while($a<$rows_count)
						$newarr[] = $all_data[$a++];
					break;
				endif;

				if($a>=$rows_count):
					// finished $all_data, so copy remaining $ips
					if($desc)
						while($d>=0)
							$newarr[] = $ips[$d--];
					else
						while($d<$count_disagree)
							$newarr[] = $ips[$d++];
					break;
				else:
					// compare the next ones of $ips and $all_data
					$sql = "select " . $ips[$d]['long_ip'] . '<' .
						sprintf('%u',ip2long($all_data[$a][$ipFieldNum]));
					$cmp = db_item($sql);
					if($desc) $cmp = !$cmp;
					if($cmp):
						$newarr[] = $ips[$d];
						if($desc) $d--; else $d++;
					else:
						$newarr[] = $all_data[$a++];
					endif;
				endif;
			endwhile;

			$all_data = $newarr;
			break;

		case('Hostname'):
			// insert by Hostname, desc or asc

			if($hostnameFieldNum == -1)
				die("Hostname must be displayed if sort field is Hostname");

			// sort $ips[] by 'hostname' 1st
			for( $i=0; $i<$count_disagree-1; $i++ )
				for( $j=$i+1; $j<$count_disagree; $j++ )
					if( strcasecmp($ips[$i]['hostname'],$ips[$j]['hostname']) > 0 )
						{$a = $ips[$i]; $ips[$i] = $ips[$j]; $ips[$j] = $a;}

			// array merge
			$d = $a = 0;
			if($desc) $d=$count_disagree-1;

			while(1):
				// if reversed order, then iterate backwards
				$cmp = $desc ? ($d<0) : ($d>=$count_disagree);
				if($cmp):
					// finished $ips, so copy remaining $all_data
					while($a<$rows_count)
						$newarr[] = $all_data[$a++];
					break;
				endif;

				if($a>=$rows_count):
					// finished $all_data, so copy remaining $ips
					if($desc)
						while($d>=0)
							$newarr[] = $ips[$d--];
					else
						while($i<$count_disagree)
							$newarr[] = $ips[$d++];
					break;
				else:
					// compare the next ones of $ips and $all_data
					$cmp = (strcasecmp($ips[$d]['hostname'],
						$all_data[$a][$hostnameFieldNum]) < 0);
					if($desc) $cmp = !$cmp;
					if($cmp):
						$newarr[] = $ips[$d];
						if($desc) $d--; else $d++;
					else:
						$newarr[] = $all_data[$a++];
					endif;
				endif;
			endwhile;

			$all_data = $newarr;
			break;

		default:
			// append to end of the array
			$all_data = array_merge($all_data, $ips);

		endswitch;

		// update the number of records
		$rows_count += $count_disagree;

	endif;

endif;

















//
//  get and print table summary data
//

print('<br><table><tr><td width=30 nowrap>&nbsp;</td><td>');
$a = array();

if($include_dns_only):

	$a[] = array('DNS Rows', $count_disagree);
	$a[] = array('Criteria', 'Show DNS comparisons only');

else:

	// get the oldest record in database
	$oldest_date	= db_item("select " . db_date_format('min(DateInserted)') .
		" from iptable $where");

	// get the newest record in database
	$newest_date	= db_item("select " . db_date_format('max(DateInserted)') .
		" from iptable $where");

	// count the number of IP addresses currently offline
	$sql = "select count(*) from iptable $where";
	$sql .= ( strlen($where) ? ' and ' : ' where ' );
	$sql .= 'DaysOffline > 0';
	$offline_count = db_item($sql);

	// print the data
	if($include_dns):
		if($count_disagree)
			$s = "$rows_count ($data_count + DNS $count_disagree)";
		else
			$s = "$rows_count (DNS: 0)";
	else:
		$s = $rows_count;
	endif;
	$a[] = array('Total', $s);

	$a[] = array('Offline', $offline_count);

	if($data_count)
		$a[] = array('Date range', "$oldest_date to $newest_date");
	else
		$a[] = array('Date range', "Not applicable");

	if($include_dns) $print_wheres[] = 'Show DNS comparisons';

	$a[] = array('Criteria', sizeof($print_wheres)? join('<br>',$print_wheres) : 'All data');

endif;



draw_key_values( $a );

print('</td></tr></table><br>');

draw_hr();







// delete buttons need $start_row, $rows_per_page and $rows_count
// for printing the page navigator
if( $auth ) require_once( "deletebuttonsheader.php" );
flush();












//
//  transform $all_data for printing
//

if(! $include_dns_only):

	// highlight all problem hostnames
	if( $hostnameFieldNum >= 0 ):
		for( $i=0, $count=sizeof($all_data); $i<$count; $i++ ):

	  	switch($all_data[$i][$hostnameFieldNum]):
	  	case(''): $all_data[$i][$hostnameFieldNum] = 'Nil';
	  	case('Hostname unknown'):
	  	case('Unspecified Hostname'):
	  		$all_data[$i][$hostnameFieldNum] = '<font color=#ff0000><b>' .
					$all_data[$i][$hostnameFieldNum] . '</b></font>';
	  	endswitch;

		endfor;
	endif;



	// highlight all problem OS
	if( $osFieldNum >= 0 ):
		for( $i=0, $count=sizeof($all_data); $i<$count; $i++ ):

	  	switch($all_data[$i][$osFieldNum]):
	  	case(''): $all_data[$i][$osFieldNum] = 'Nil';
	  	case('OS info unretrievable'):
	  	case('Unspecified OS'):
	  	case('OS unknown'):
	  		$all_data[$i][$osFieldNum] = '<font color=#0000ff><b>' .
					$all_data[$i][$osFieldNum] . '</b></font>';
	  	endswitch;

		endfor;
	endif;

endif;






//
//  print entire <table>...</table>
//

require_once('draw_data_table.php');

draw_data_table($fields, &$all_data, $start_row, $rows_per_page,
	'sort_field', 'sort_order', $auth);
	// $auth for $delete_buttons









//
//  print document footer - finish printing whole webpage
//

if( $auth ) require_once( 'deletebuttonsfooter.php' );

print( '</body></html>' );
flush();











//...................................................................

//
//  now, update the database!
//

// the database is updated only at the end of the query, so
// the user wouldn't have to wait over 20 seconds just for
// the database to be updated!

$updateRunning = `ps -A | grep updatederived`;

// run in background!
if(! $updateRunning) // unfortunately, dir is hardcoded
	system( "/export/home1/supervision/ecescan/updatederiveddata &> /dev/null &" );

?>
