
/* RCS Information:
 *
 * $Id$
 * $Revision$
 * $Date$
 * $Author$
 * $Locker$
 * 
 */

/*****************************************************************************  
*  *  MODULE NAME : GETOPT.H  
*  *  COPYRIGHTS:  
*             This module contains code made available by IBM  
*             Corporation on an AS IS basis.  Any one receiving the  
*             module is considered to be licensed under IBM copyrights  
*             to use the IBM-provided source code in any way he or she  
*             deems fit, including copying it, compiling it, modifying  
*             it, and redistributing it, with or without  
*             modifications.  No license under any IBM patents or  
*             patent applications is to be implied from this copyright  
*             license.  
*  *             A user of the module should understand that IBM cannot  
*             provide technical support for the module and will not be  
*             responsible for any consequences of use of the program.  
*  *             Any notices, including this one, are not to be removed  
*             from the module without the prior written consent of  
*             IBM.  
*  *  AUTHOR:   Original author:  
*                 G. R. Blair (BOBBLAIR at AUSVM1)  
*                 Internet: bobblair@bobblair.austin.ibm.com  
*  *            Extensively revised by:  
*                 John Q. Walker II, Ph.D. (JOHHQ at RALVM6)  
*                 Internet: johnq@ralvm6.vnet.ibm.com  
*  *****************************************************************************/
  
/******************************************************************************  
* getopt()  
*  * The getopt() function is a command line parser.  It returns the next  
* option character in argv that matches an option character in opstring.  
*  * The argv argument points to an array of argc+1 elements containing argc  
* pointers to character strings followed by a null pointer.  
*  * The opstring argument points to a string of option characters; if an  
* option character is followed by a colon, the option is expected to have  
* an argument that may or may not be separated from it by white space.  
* The external variable optarg is set to point to the start of the option  
* argument on return from getopt().  
*  * The getopt() function places in optind the argv index of the next argument  
* to be processed.  The system initializes the external variable optind to  
* 1 before the first call to getopt().  
*  * When all options have been processed (that is, up to the first nonoption  
* argument), getopt() returns EOF.  The special option "--" may be used to  
* delimit the end of the options; EOF will be returned, and "--" will be  
* skipped.  
*  * The getopt() function returns a question mark (?) when it encounters an  
* option character not included in opstring.  This error message can be  
* disabled by setting opterr to zero.  Otherwise, it returns the option  
* character that was detected.  
*  * If the special option "--" is detected, or all options have been  
* processed, EOF is returned.  
*  * Options are marked by either a minus sign (-) or a slash (/).  
*  * No errors are defined.  
*****************************************************************************/  
   
int getopt(int argc, char *const argv[], const char *opstring);

/*****************************************************************************  
 *
 * $Log: $
 *
*****************************************************************************/  

